Unit ef03r1_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure ef03r1(N :Integer; P1 :Real; P2 :Real; P3 :Real;
                 var H :Array of Real; var D :Array of Real;
                 var C1 :Array of Real; var C2 :Array of Real;
                 var C3 :Array of Real);

implementation

procedure ef03r1(N :Integer; P1 :Real; P2 :Real; P3 :Real;
                 var H :Array of Real; var D :Array of Real;
                 var C1 :Array of Real; var C2 :Array of Real;
                 var C3 :Array of Real);
var
I :Integer;
R,R1,R2,R4,S2,S4,S6 :Real;
const
J :Integer = 2;
R3 :Real = 0.0;
S1 :Real = 0.0;
S3 :Real = 0.0;
S5 :Real = 0.0;
label
_10,_20,_30,_40;
begin
R1 := 1.0/H[0];
_10:
R4 := P3/D[J-1];
R2 := 1.0/H[J-1];
_20:
S2 := R1*R1*(R3 + R4);
S4 := R1*R2*R4;
S6 := P2*R1;
R := S6 + S2 + S3;
I := J - 1;
C1[I-1] := P1*D[I-1] + R + S1 + S3 + S5;
C2[I-1] := -R - S4;
C3[I-1] := S4;
S1 := S2;
S3 := S4;
S5 := S6;
R1 := R2;
R3 := R4;
J := J + 1;
if ( J - N ) < 0
 then goto _10
 else if ( J - N ) > 0
       then goto _40
       else goto _30;
_30:
R4 := 0.0;
R2 := 0.0;
goto _20;
_40:
C1[N-1] := P1*D[N-1] + S2 + S6;
C2[N-1] := 0.0;
C3[N-1] := 0.0;
end;

end.
