Unit ef03r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, EF03R1_p, EF03R2_p, EF03R3_p, AVZ2R_p, EF03R4_p;

procedure ef03r(var M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; var DELTA :Array of Real;
                var H :Array of Real; var D :Array of Real; var P1 :Real;
                var P2 :Real; var P3 :Real; P4 :Real; L :Integer;
                var U :Array of Real; var B :Array of Real);

implementation

procedure ef03r(var M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; var DELTA :Array of Real;
                var H :Array of Real; var D :Array of Real; var P1 :Real;
                var P2 :Real; var P3 :Real; P4 :Real; L :Integer;
                var U :Array of Real; var B :Array of Real);
var
I,I1,I2,I3,I4,I5,IM,IP,IS_,IXP,J,K,K1,K2,K3,K4,K5,NP :Integer;
R,S,W,W1 :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,_160,_170,
_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,_300,_310,_320;
begin
K := N + N;
K1 := K + N;
K2 := Trunc( 3*N + M );
K3 := K2 + M;
K4 := K3 + N;
K5 := K4 + N;
case L of
 1: goto _10;
 2: goto _40;
end;
_10:
EF03R1(N,P1,P2,P3,H,D,B[0],B[N+0],B[K+0]);
EF03R2(N,B[0],B[N+0],B[K+0]);
EF03R3(M,N,A,D,B[0],B[N+0],B[K+0]);
for I:=1 to M do
 begin
  I1 := K1 + I;
  B[I1-1] := 0.0;
  for J:=1 to N do
   begin
    B[I1-1] := B[I1-1] + A[(I-1)+(J-1)*M]*A[(I-1)+(J-1)*M];
_20:
   end;
_30:
 end;
_40:
for J:=1 to N do
 begin
  U[J-1] := 0.0;
_50:
 end;
IS_ := 0;
_60:
IP := 0;
_70:
NP := 1;
for I:=1 to M do
 begin
  I2 := K2 + I;
  B[I2-1] := 0.0;
  for J:=1 to N do
   begin
    B[I2-1] := B[I2-1] + A[(I-1)+(J-1)*M]*U[J-1];
_80:
   end;
_90:
 end;
_100:
for I:=1 to M do
 begin
  I1 := K1 + I;
  I2 := K2 + I;
  I5 := K5 + I;
  B[I5-1] := Abs(B[I2-1] - F[I-1]) - DELTA[I-1];
  if ( B[I5-1] - 1.E-4*DELTA[I-1] ) < 0
   then goto _130
   else if ( B[I5-1] - 1.E-4*DELTA[I-1] ) > 0
         then goto _110
         else goto _130;
_110:
  B[I5-1] := B[I5-1]/Sqrt(B[I1-1]);
  W1 := 0.1*DELTA[I-1]/Sqrt(B[I1-1]);
  if ( B[I5-1] - W1 ) < 0
   then goto _140
   else if ( B[I5-1] - W1 ) > 0
         then goto _120
         else goto _140;
_120:
  NP := 2;
  goto _140;
_130:
  B[I5-1] := 0.0;
_140:
 end;
case NP of
 1: goto _320;
 2: goto _150;
end;
_150:
if ( IS_ - N ) < 0
 then goto _180
 else if ( IS_ - N ) > 0
       then goto _160
       else goto _180;
_160:
IS_ := 0;
for I:=1 to M do
 begin
  DELTA[I-1] := DELTA[I-1] + P4*DELTA[I-1];
_170:
 end;
goto _40;
_180:
R := AVZ2R(B[K5+0],M,1,IM);
IM := IM;
_190:
I1 := K1 + IM;
I2 := K2 + IM;
W := B[I2-1] - F[IM-1];
S := R*Sign(1.0,W)/Sqrt(B[I1-1]);
for J:=1 to N do
 begin
  U[J-1] := U[J-1] - S*A[(IM-1)+(J-1)*M];
_200:
 end;
IP := IP + 1;
case IP of
 1: goto _210;
 2: goto _230;
 3: goto _290;
end;
_210:
IXP := IM;
for J:=1 to N do
 begin
  I3 := K3 + J;
  B[I3-1] := U[J-1];
_220:
 end;
goto _70;
_230:
R := 0.0;
for J:=1 to N do
 begin
  R := R + A[(IXP-1)+(J-1)*M]*U[J-1];
_240:
 end;
I2 := K2 + IXP;
I1 := K1 + IXP;
B[I2-1] := R;
W := Abs(R-F[IXP-1]) - DELTA[IXP-1];
if ( W - 1.E-4*DELTA[IXP-1] ) < 0
 then goto _250
 else if ( W - 1.E-4*DELTA[IXP-1] ) > 0
       then goto _260
       else goto _250;
_250:
R := 0.0;
goto _270;
_260:
R := W/Sqrt(B[I1-1]);
_270:
IM := IXP;
for J:=1 to N do
 begin
  I4 := K4 + J;
  B[I4-1] := U[J-1];
_280:
 end;
goto _190;
_290:
R := 0.0;
W := 0.0;
for J:=1 to N do
 begin
  I3 := K3 + J;
  I4 := K4 + J;
  S := B[I3-1] - B[I4-1];
  R := R + S*S;
  W := W + S*(B[I3-1] - U[J-1]);
_300:
 end;
W := R/W;
for J:=1 to N do
 begin
  I3 := K3 + J;
  U[J-1] := B[I3-1] + W*(U[J-1] - B[I3-1]);
_310:
 end;
IS_ := IS_ + 1;
goto _60;
_320:
EF03R4(U,N,B[0],B[N+0],B[K+0]);
end;

end.
